SystemOrganization addCategory: #Metaprogramacion!

Object subclass: #ClasePruebaConMetodoAbstracto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClasePruebaConMetodoAbstracto methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/19/2013 20:59'!
metodoAbstracto
	self subclassResponsibility.! !

Object subclass: #ClasePruebaSinMetodosAbstractos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClasePruebaSinMetodosAbstractos methodsFor: 'as yet unclassified' stamp: 'ebastian 6/22/2013 16:54'!
mensajeQueExisteYNoEsAbstracto
	^self.! !

Object subclass: #ClasePruebaSinMetodosPropios
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

Object subclass: #Hierarchy01
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

Hierarchy01 subclass: #Child01
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

Child01 subclass: #GrandChild01
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

Hierarchy01 subclass: #Child02
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

Hierarchy01 subclass: #Child03
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!Child03 methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/23/2013 18:09'!
abstractMethod
	self subclassResponsibility.! !

Hierarchy01 subclass: #Child04
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

Child04 subclass: #GrandChild02
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!GrandChild02 methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/23/2013 18:10'!
abstractMethod
	^self.! !

Child04 subclass: #GrandChild03
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!Hierarchy01 methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/23/2013 18:08'!
abstractMethod
	self subclassResponsibility.! !

TestCase subclass: #MetaprogamacionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/23/2013 17:53'!
test01LookForMissingImplementorsShouldRaiseAnExceptionWhenMessageDoesNotExists
	
	self should: [
			ClasePruebaSinMetodosPropios lookForMisingImplementors: #mensajeQueNoExiste
			]
		raise: Error
		withExceptionDo: [ :anError |  self assert: anError messageText = 'No existe el Mensaje'].
	 ! !

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/23/2013 17:54'!
test02LookForMissingImplementorsShouldRaiseAnExceptionWhenMessageDoesNotExists
	
	self should: [
			ClasePruebaSinMetodosPropios class lookForMisingImplementors: #mensajeQueNoExiste
			]
		raise: Error
		withExceptionDo: [ :anError |  self assert: anError messageText = 'No existe el Mensaje'].
	 ! !

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/23/2013 17:54'!
test03LookForMissingImplementorsShouldRaiseAnExceptionWhenMessageIsNotAbstract
	
	self should: [
			ClasePruebaSinMetodosAbstractos lookForMisingImplementors: #mensajeQueExisteYNoEsAbstracto
			]
		raise: Error
		withExceptionDo: [ :anError |  self assert: anError messageText = 'El Metodo no es abstracto'].
	 ! !

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'ebastian 6/22/2013 17:09'!
test04LookForMissingImplementorsReturnsAnEmptyListIfTheMessageIsImplemented
	
	self assert: (ClasePruebaConMetodoAbstracto lookForMisingImplementors: #metodoAbstracto) isEmpty.! !

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/23/2013 18:10'!
test05LookForMissingImplementorsReturnsAListIfTheMessageIsImplemented
	
	| classesWithoutAbstractMethodImplementation |
	classesWithoutAbstractMethodImplementation := OrderedCollection new.
	classesWithoutAbstractMethodImplementation add: GrandChild01.
	classesWithoutAbstractMethodImplementation add: Child02.
	classesWithoutAbstractMethodImplementation add: Child03.
	classesWithoutAbstractMethodImplementation add: GrandChild03.
	self assert: (Hierarchy01 lookForMisingImplementors: #abstractMethod) = classesWithoutAbstractMethodImplementation.! !

!ClassDescription methodsFor: '*Metaprogramacion' stamp: 'SebastianGarbi 6/23/2013 18:03'!
giveMeLeavesWhatDoesntImplement: aMessage
	| leaves |
	
	leaves := OrderedCollection new.
	(self subclasses isEmpty) 	ifTrue: [ self methodDict at: aMessage ifPresent: [:method | (method isAbstract ) ifTrue: [leaves add: self] ] ifAbsent: [ leaves add: self ] ]
								ifFalse: [ self subclasses do: [ :aSubclass | leaves addAll: (aSubclass giveMeLeavesWhatDoesntImplement: aMessage) ] ].
								
	^leaves.! !

!ClassDescription methodsFor: '*Metaprogramacion' stamp: 'ebastian 6/23/2013 12:57'!
lookForMisingImplementors: aMessage
	| method classesWhichDontHaveTheMessage |
	classesWhichDontHaveTheMessage := OrderedCollection new.
	method := self methodDict at: aMessage  ifAbsent: [ Error signal: 'No existe el Mensaje' ].
	(method isAbstract) ifFalse: [Error signal: 'El Metodo no es abstracto'].
	(method isAbstract) ifTrue: [ self subclasses do: [ :aSubclass | classesWhichDontHaveTheMessage addAll: (aSubclass giveMeLeavesWhatDoesntImplement: aMessage) ] ].
	^classesWhichDontHaveTheMessage.! !
